package com.example.acer.agendita_mysql_c;

import android.app.ProgressDialog;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;
import java.util.ArrayList;

import librerias.ConexionWeb;
import librerias.Datos;
import librerias.MiBaseDatos;
import librerias.Parametros;


public class BajasFragment extends Fragment implements View.OnClickListener {
        Button btnCancelar, btnBuscar, btnElminiar;
        EditText txtTelefono;
        TextView txtNombre, txtApellido;
        MiBaseDatos baseDatos;
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        return inflater.inflate(R.layout.fragment_bajas, container, false);
    }
    public void onStart(){
        super.onStart();
        btnBuscar=(Button)getView().findViewById(R.id.btnBuscarBajas);
        btnCancelar=(Button)getView().findViewById(R.id.btnCancelarBajas);
        btnElminiar=(Button)getView().findViewById(R.id.btnEliminarBaja);
        txtApellido=(TextView)getView().findViewById(R.id.txtApellidoBajas);
        txtNombre=(TextView)getView().findViewById(R.id.txtNombreBajas);
        txtTelefono=(EditText)getView().findViewById(R.id.txtTelBuscarBajas);
        btnCancelar.setOnClickListener(this);
        btnElminiar.setOnClickListener(this);
        btnBuscar.setOnClickListener(this);
    }

    @Override
    public void onClick(View v) {
        if(v.getId()==R.id.btnBuscarBajas){
            if(Parametros.conexion.equals("Local")){
                buscarLocal();
            }else if(Parametros.conexion.equals("Remoto")){
                buscarRemoto();
            }
        }else if(v.getId()==R.id.btnEliminarBaja){
            if(Parametros.conexion.equals("Local")){
                eliminarLocal();
            }else if(Parametros.conexion.equals("Remoto")){
                eliminarRemoto();
            }
        }else if (v.getId()==R.id.btnCancelarBajas){
            cancelar();
        }
    }
    public void cancelar(){
        txtTelefono.setText("");
        txtApellido.setText("");
        txtNombre.setText("");
    }
    public void buscarLocal() {
        String telefono = txtTelefono.getText().toString();
        if (telefono.equals("")) {
            Toast.makeText(getContext(), "Favor de introducir un Telefono", Toast.LENGTH_SHORT).show();
        } else {
            baseDatos = new MiBaseDatos(getContext());
            SQLiteDatabase sql = baseDatos.getReadableDatabase();
            String[] columnas = {
                    Parametros.campo_nombre,
                    Parametros.campo_apellido,
                    Parametros.campo_telefono};
            String consulta = "telefono='" + telefono + "'";
            Cursor cursor = sql.query(Parametros.tabla_datos, columnas, consulta, null, null, null, null);

            if (cursor.getCount() != 0) {
                cursor.moveToFirst();
                txtNombre.setText(cursor.getString(cursor.getColumnIndex(Parametros.campo_nombre)));
                txtApellido.setText(cursor.getString(cursor.getColumnIndex(Parametros.campo_apellido)));

            }
            sql.close();
        }
    }
    public void eliminarLocal(){
        String telefono=txtTelefono.getText().toString();
        String nombre=txtNombre.getText().toString();
        String apellido=txtTelefono.getText().toString();
        if(telefono.equals("")||apellido.equals("")||nombre.equals("")){
            Toast.makeText(getContext(), "Favor de Buscar un Telefono", Toast.LENGTH_SHORT).show();
        }else{
            String clausula=Parametros.campo_telefono+"='"+telefono+"' and "+Parametros.campo_nombre+"='"+nombre+"'";
            baseDatos=new MiBaseDatos(getContext());
            SQLiteDatabase sql=baseDatos.getWritableDatabase();
            sql.delete(Parametros.tabla_datos,clausula,null);
            sql.close();
            cancelar();
        }
    }
    public void buscarRemoto(){
        if (txtTelefono.getText().toString().equals("")){
            Toast.makeText(getContext(), "Favor de Introducir un Telefono", Toast.LENGTH_SHORT).show();
        }else {
            ArrayList<String> valores = new ArrayList();
            String telefono = txtTelefono.getText().toString();
            valores.add(0, telefono);
            new TareaBuscarWeb(valores).execute();
        }
    }
    public void mostrarDato(Datos dato){
        Log.d("NOmbre:",dato.getNombre());
        txtNombre.setText(dato.getNombre());
        txtApellido.setText(dato.getApellido());
    }
    public void eliminarRemoto(){
        String nombre=txtNombre.getText().toString();
        String telefono=txtTelefono.getText().toString();
        if(nombre.equals("")||telefono.equals("")){
            Toast.makeText(getContext(), "Favor de Buscar un Telefono", Toast.LENGTH_SHORT).show();
        }else{
            ArrayList<String> valores=new ArrayList();
            valores.add(nombre);
            valores.add(telefono);
            new TareaEliminarWeb(valores).execute();
        }
    }
    private class TareaBuscarWeb extends AsyncTask<Void, Void, String> {
        String URL = "http://"+Parametros.servidor+"/EjemploMysql/Buscar.php";
        // private JSONArray jsonDatos = null;
        ArrayList<String> valores;
        private JSONArray jsonDatos = null;
        Datos dato;
        private ProgressDialog nDialog;
        public TareaBuscarWeb(ArrayList<String> valores){
            nDialog = new ProgressDialog(getActivity());
            this.valores=valores;
        }
        @Override
        //accion principal
        protected String doInBackground(Void... voids) {

            ArrayList<String> keys = new ArrayList();
            ArrayList<String> valor = new ArrayList();
            keys.add(0, "telefono");valor.add(0, valores.get(0));
            ConexionWeb conexionWeb = new ConexionWeb();
            try {
                String jsonStr = conexionWeb.buscarDato(URL, conexionWeb.armarGET(keys,valor));

                JSONObject json=new JSONObject(jsonStr);
                if(!json.isNull("datos")) {

                    jsonDatos = json.getJSONArray("datos");
                    for (int i = 0; i < jsonDatos.length(); i++) {
                        JSONObject jsonObject = jsonDatos.getJSONObject(i);
                        dato = new Datos(jsonObject.getString("nombre"),
                                jsonObject.getString("apellido"),
                                jsonObject.getString("telefono"));
                    }
                }else{
                    Log.d("Json:","Vacio");
                }
                //duracion de la ventana 3000 milisegundos
                Thread.sleep(1000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            } catch (JSONException e) {
                e.printStackTrace();
            }
            return null;
        }
        //accion previa
        protected void onPreExecute() {
            nDialog.show();
            nDialog.setContentView(R.layout.dialogo_grabando);


        }
        //accion posterior
        protected void onPostExecute(String result) {
            super.onPostExecute(result);

            if (nDialog.isShowing()) {
                nDialog.dismiss();
                mostrarDato(dato);

            }
        }

    }
    private class TareaEliminarWeb extends AsyncTask<Void, Void, String> {
        String URL = "http://"+Parametros.servidor+"/EjemploMysql/Eliminar.php";
        ArrayList<String> valores;

        private ProgressDialog nDialog;
        public TareaEliminarWeb(ArrayList<String> valores){
            nDialog = new ProgressDialog(getActivity());
            this.valores=valores;
        }
        @Override
        //accion principal
        protected String doInBackground(Void... voids) {

            ArrayList<String> keys = new ArrayList();
            ArrayList<String> valor = new ArrayList();
            keys.add(0, "nombreEliminar");valor.add(0, valores.get(0));
            keys.add(1, "telefonoEliminar");valor.add(1, valores.get(1));
            ConexionWeb conexionWeb = new ConexionWeb();
            conexionWeb.grabarDatos(URL, conexionWeb.armarGET(keys, valor));
            try {
                //duracion de la ventana 3000 milisegundos
                Thread.sleep(1000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            return null;
        }
        //accion previa
        protected void onPreExecute() {
            nDialog.show();
            nDialog.setContentView(R.layout.dialogo_grabando);


        }
        //accion posterior
        protected void onPostExecute(String result) {
            super.onPostExecute(result);

            if (nDialog.isShowing()) {
                nDialog.dismiss();
                cancelar();
            }
        }

    }
}
